# Copyright (c) 2017 Applause Inc. All rights reserved.

YAML_SETUP_RELEASE_CONFIGURATION_PLIST_PATH_KEY = 'plist'
YAML_SETUP_RELEASE_CONFIGURATION_OUTPUT_PATH_KEY = 'output_path'
YAML_SETUP_RELEASE_CONFIGURATION_PRODUCT_NAME_KEY = 'product_name'
YAML_SETUP_RELEASE_CONFIGURATION_POD_NAME_KEY = 'pod_name'
YAML_SETUP_RELEASE_CONFIGURATION_S3_UPLOAD_BUCKET_KEY = 's3_bucket'
YAML_SETUP_RELEASE_CONFIGURATION_S3_UPLOAD_FOLDER_KEY = 's3_upload_folder'
YAML_SETUP_RELEASE_CONFIGURATION_TEST_APPS_PLISTS_KEY = 'test_apps_plists'
YAML_SETUP_RELEASE_CONFIGURATION_TEST_APPS_VERSION_CODE_FILES_KEY = 'test_apps_version_code_files'
YAML_SETUP_RELEASE_CONFIGURATION_EXPORT_OPTIONS_PLIST_KEY = 'export_options_plist'

class ReleaseConfiguration
	attr_accessor :plist, :output_path, :product_name, :pod_name, :s3_bucket,
			:s3_upload_folder, :test_apps_plists, :test_apps_version_code_files,
			:export_options_plist
	def parse_setup(setup)
		if setup.has_key?(YAML_SETUP_RELEASE_CONFIGURATION_PLIST_PATH_KEY)
			@plist = setup[YAML_SETUP_RELEASE_CONFIGURATION_PLIST_PATH_KEY]
		end
		if setup.has_key?(YAML_SETUP_RELEASE_CONFIGURATION_OUTPUT_PATH_KEY)
			@output_path = setup[YAML_SETUP_RELEASE_CONFIGURATION_OUTPUT_PATH_KEY]
		end
		if setup.has_key?(YAML_SETUP_RELEASE_CONFIGURATION_PRODUCT_NAME_KEY)
			@product_name = setup[YAML_SETUP_RELEASE_CONFIGURATION_PRODUCT_NAME_KEY]
		end
		if setup.has_key?(YAML_SETUP_RELEASE_CONFIGURATION_POD_NAME_KEY)
			@pod_name = setup[YAML_SETUP_RELEASE_CONFIGURATION_POD_NAME_KEY]
		end
		if setup.has_key?(YAML_SETUP_RELEASE_CONFIGURATION_S3_UPLOAD_BUCKET_KEY)
			@s3_bucket = setup[YAML_SETUP_RELEASE_CONFIGURATION_S3_UPLOAD_BUCKET_KEY]
		end
		if setup.has_key?(YAML_SETUP_RELEASE_CONFIGURATION_S3_UPLOAD_FOLDER_KEY)
			@s3_upload_folder = setup[YAML_SETUP_RELEASE_CONFIGURATION_S3_UPLOAD_FOLDER_KEY]
		end
		if setup.has_key?(YAML_SETUP_RELEASE_CONFIGURATION_TEST_APPS_PLISTS_KEY)
			@test_apps_plists = setup[YAML_SETUP_RELEASE_CONFIGURATION_TEST_APPS_PLISTS_KEY]
		end
		if setup.has_key?(YAML_SETUP_RELEASE_CONFIGURATION_TEST_APPS_VERSION_CODE_FILES_KEY)
			@test_apps_version_code_files = setup[YAML_SETUP_RELEASE_CONFIGURATION_TEST_APPS_VERSION_CODE_FILES_KEY]
		end
		if setup.has_key?(YAML_SETUP_RELEASE_CONFIGURATION_EXPORT_OPTIONS_PLIST_KEY)
			@export_options_plist = setup[YAML_SETUP_RELEASE_CONFIGURATION_EXPORT_OPTIONS_PLIST_KEY]
		end
	end
end
