# Copyright (c) 2017 Applause Inc. All rights reserved.

YAML_SETUP_DESTINATION_PLATFORM_KEY = 'platform'
YAML_SETUP_DESTINATION_NAME_KEY = 'name'
YAML_SETUP_DESTINATION_OS_KEY = 'os'
YAML_SETUP_DESTINATION_ARCH_KEY = 'arch'

class TestDestination
	attr_accessor :platform, :name, :os_version, :arch
	def parse_setup(setup)
		if setup.has_key?(YAML_SETUP_DESTINATION_PLATFORM_KEY)
			@platform = setup[YAML_SETUP_DESTINATION_PLATFORM_KEY]
		end
		if setup.has_key?(YAML_SETUP_DESTINATION_NAME_KEY)
			@name = setup[YAML_SETUP_DESTINATION_NAME_KEY]
		end
		if setup.has_key?(YAML_SETUP_DESTINATION_OS_KEY)
			@os_version = setup[YAML_SETUP_DESTINATION_OS_KEY]
		end
		if setup.has_key?(YAML_SETUP_DESTINATION_ARCH_KEY)
			@arch = setup[YAML_SETUP_DESTINATION_ARCH_KEY]
		end
	end
	def build_destination_string
		destination = ''
		destination = append_value_for_key(destination, @platform, 'platform')
		destination = append_value_for_key(destination, @name, 'name')
		destination = append_value_for_key(destination, @os_version, 'OS')
		destination = append_value_for_key(destination, @arch, 'arch')
		return destination
	end
	def append_value_for_key(destination, value, key)
		if value
			if destination.length > 0
				destination += ','
			end
			destination += "#{key}=#{value}"
		end
		return destination
	end
end
