# Copyright (c) 2017 Applause Inc. All rights reserved.

require 'yaml'

UPLOAD_CONFIGURATION_YAML_PATH = 'app_upload.yaml'

YAML_CONFIGURATIONS_KEY = 'configurations'
YAML_CONFIG_NAME_KEY = 'name'
YAML_CONFIG_SERVICE_KEY = 'service'
YAML_CONFIG_APPLICATION_KEY_KEY = 'application_key'
YAML_CONFIG_COMPANY_ID_KEY = 'company_id'
YAML_CONFIG_APP_ID_KEY = 'app_id'
YAML_CONFIG_PUBLISH_EMAIL_KEY = 'publish_email'
YAML_CONFIG_DISTRIBUTION_GROUP_KEY = 'distribution_group'

class UploadConfiguration
  attr_accessor :application_key, :service, :company_id, :app_id, :publish_email, :distribution_group

  def parse_configuration(setup)
    if setup.has_key?(YAML_CONFIG_APPLICATION_KEY_KEY)
      @application_key = setup[YAML_CONFIG_APPLICATION_KEY_KEY]
    end
    if setup.has_key?(YAML_CONFIG_SERVICE_KEY)
      @service = setup[YAML_CONFIG_SERVICE_KEY]
    end
    if setup.has_key?(YAML_CONFIG_COMPANY_ID_KEY)
      @company_id = setup[YAML_CONFIG_COMPANY_ID_KEY]
    end
    if setup.has_key?(YAML_CONFIG_APP_ID_KEY)
      @app_id = setup[YAML_CONFIG_APP_ID_KEY]
    end
    if setup.has_key?(YAML_CONFIG_PUBLISH_EMAIL_KEY)
      @publish_email = setup[YAML_CONFIG_PUBLISH_EMAIL_KEY]
      if @publish_email.kind_of?(Array) == false
        @publish_email = [@publish_email]
      end
    end
    if setup.has_key?(YAML_CONFIG_DISTRIBUTION_GROUP_KEY)
      @distribution_group = setup[YAML_CONFIG_DISTRIBUTION_GROUP_KEY]
    end
  end

  class << self
    	def load(configuration_name)
      	upload_config = UploadConfiguration.new
      	yaml = YAML.load_file(UPLOAD_CONFIGURATION_YAML_PATH)
      	if yaml.has_key?(YAML_CONFIGURATIONS_KEY)
      		setups = yaml[YAML_CONFIGURATIONS_KEY]
    			parse_named_config setups, upload_config, configuration_name
      	end
      	return upload_config
      end

      private
      def parse_named_config(setups, upload_configuration, configuration_name)
      	filtered_setups = setups.select { |s| s[YAML_CONFIG_NAME_KEY] == configuration_name}
      	setup = filtered_setups.first
      	if setup
      		upload_configuration.parse_configuration(setup)
      	end
      end
  end
end
