# Copyright (c) 2017 Applause Inc. All rights reserved.

PLIST_BUDDY = '/usr/libexec/PlistBuddy'
PLIST_VERSION_KEY = "CFBundleShortVersionString"
PLIST_BUILD_NUMBER_KEY = "CFBundleVersion"

module Plist
  def version(info_plist_path)
  	return print("#{info_plist_path}", "#{PLIST_VERSION_KEY}")
  end

  def set_version(info_plist_path, version)
  	return set("#{info_plist_path}", "#{PLIST_VERSION_KEY}", "#{version}")
  end

  def build_number(info_plist_path)
  	return print("#{info_plist_path}", "#{PLIST_BUILD_NUMBER_KEY}")
  end

  def set_build_number(info_plist_path, build_number)
  	return set("#{info_plist_path}", "#{PLIST_BUILD_NUMBER_KEY}", "#{build_number}")
  end

  def set(info_plist_path, key, value)
    return `#{PLIST_BUDDY} -c "Set :#{key} #{value}" "#{info_plist_path}"`.strip
  end

  def print(info_plist_path, key)
    return `#{PLIST_BUDDY} -c "Print :#{key}" "#{info_plist_path}"`.strip
  end
end
