# Copyright (c) 2017 Applause Inc. All rights reserved.

require 'aws-sdk'

module S3
  def upload_file(file_path, save_path, bucket_name)
  	s3 = Aws::S3::Resource.new(region:'us-west-1' ,endpoint: 'https://s3.amazonaws.com')
  	object = s3.bucket(bucket_name).object(save_path)
  	object.upload_file file_path, acl: 'public-read'
  	return object.public_url
  end

  def upload_archived_app(app_zip_path, dsym_zip_path, info_plist_path, bucket_name)
  	version = application_version(info_plist_path)
  	app_url = upload_file(app_zip_path, File.join(version, File.basename(app_zip_path)), bucket_name)
  	dsym_url = upload_file(dsym_zip_path, File.join(version, File.basename(dsym_zip_path)), bucket_name)
  	return app_url, dsym_url
  end
end
